 

<!-- <app-experiment-sub-toolbar></app-experiment-sub-toolbar> -->

<div class="contentBlock" style="padding: 30px; padding-bottom: 10%;" class="ts-title">
    <section class="mat-typography title-group">
        <mat-button-toggle-group name="fontStyle" aria-label="Font Style">
            <mat-button-toggle value="bold"  (click)="goTo('add')"  *ngIf="getTicketingStatus() != 'add'"  class="ts-title">
                <mat-icon aria-hidden="false" aria-label="">post_add</mat-icon>
            </mat-button-toggle>
            <mat-button-toggle value="bold"   *ngIf="getTicketingStatus() == 'list'" (click)="ngOnInit()"  class="ts-title">
                <mat-icon aria-hidden="false" aria-label="">refresh</mat-icon>
            </mat-button-toggle>
            <mat-button-toggle value="bold"   (click)="goTo('list')"  *ngIf="getTicketingStatus() != 'list'" class="ts-title">
                <mat-icon aria-hidden="false" >keyboard_arrow_left</mat-icon>
            </mat-button-toggle>
        </mat-button-toggle-group>

        <mat-divider></mat-divider>
    </section>

    <!-- Content -->
    <!-- Tickets list -->
    <table mat-table [dataSource]="tickets" class="ts-title" *ngIf="getTicketingStatus() == 'list'&&!fetching">

        <ng-container matColumnDef="id">
            <th mat-header-cell *matHeaderCellDef> Id </th>
            <td mat-cell *matCellDef="let element"> {{element.id}} </td>
        </ng-container>

        <!--
        <ng-container matColumnDef="product">
            <th mat-header-cell *matHeaderCellDef> Product </th>
            <td mat-cell *matCellDef="let element"> {{element.product}} </td>
        </ng-container>
        -->

        <ng-container matColumnDef="component">
            <th mat-header-cell *matHeaderCellDef fxShow.xs="false"> Component </th>
            <td mat-cell *matCellDef="let element" fxShow.xs="false"> {{element.component}} </td>
        </ng-container>

        <ng-container matColumnDef="status">
            <th mat-header-cell *matHeaderCellDef fxShow.xs="false"> Status </th>
            <td mat-cell *matCellDef="let element" fxShow.xs="false"> {{element.status}} </td>
        </ng-container>

        <ng-container matColumnDef="summary">
            <th mat-header-cell *matHeaderCellDef fxShow.xs="false" class="ticket-summary"> Summary </th>
            <td mat-cell *matCellDef="let element" fxShow.xs="false" class="ticket-summary-text"> {{element.summary}} </td>
        </ng-container>

        <ng-container matColumnDef="actions">
            <th mat-header-cell *matHeaderCellDef> Actions </th>
            <td mat-cell *matCellDef="let element">
            <mat-button-toggle-group name="fontStyle" aria-label="Font Style">
                <mat-button-toggle value="bold" class="ts-title">
                    <mat-icon aria-hidden="false" aria-label="Example edit icon" class="ts-title">remove_red_eye</mat-icon>
                </mat-button-toggle>
            </mat-button-toggle-group>
            </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let element; columns: displayedColumns;" class="element-row" (click)=ticketDetails(element)></tr>

    </table>
    <mat-paginator #paginator
        [length]="totalTickets" [pageSize]="numTickets" [pageIndex]="currentPage"
        showFirstLastButtons
        (page)="pageEvents($event)"
        *ngIf="getTicketingStatus() == 'list'&&!fetching"
        class="ts-title"
        >
    </mat-paginator>

    <mat-spinner *ngIf="fetching" class="my-spinner"></mat-spinner>


    <!-- New ticket form -->
    <mat-card class="ts-title" *ngIf="getTicketingStatus() == 'add'&&!fetching"  class="add-ticket-xs ts-title" style="box-shadow: none;">
        <mat-card-title style="text-align: center;">
          
                Add new ticket
          
        </mat-card-title>
        <mat-card-content class="ts-title"> 
            <form [formGroup]="addTicketForm">

                <mat-form-field>
                    <mat-select placeholder="Select a Product" name="product" formControlName="product" required (selectionChange)="getComponents()">
                    <mat-option *ngFor="let product of products" [value]="product.name" >{{ product.name }}</mat-option>
                    </mat-select>
                </mat-form-field>

                <mat-form-field >
                    <mat-select placeholder="Select a Component" name="component" formControlName="component" required>
                    <mat-option *ngFor="let component of components" [value]="component.name" >{{ component.name }}</mat-option>
                    </mat-select>
                </mat-form-field>

                <mat-form-field>
                    <mat-label>Summary</mat-label>
                    <input  matInput  formControlName="summary" placeholder="Summary" name="summary"  required>
                </mat-form-field>

                <mat-form-field>
                    <mat-label>Description</mat-label>
                    <textarea matInput formControlName="description" placeholder="Ticket details" name="description" required></textarea>
                </mat-form-field>
                <div style="text-align: center;" >
                    <button mat-raised-button (click)="onSubmit()" color="primary">Create</button>
                </div>
            </form>
        </mat-card-content>

    </mat-card>


    <!-- Ticket Details -->
    <div class="detailsContainer" *ngIf="getTicketingStatus() == 'details'">

        <section class="ticketSummary ts-title">
            <h1>Ticket: {{selectedTicket['summary']}}</h1>
            <mat-divider></mat-divider>
        </section>

        <section class="commentsHeader">
            <h2>Comments</h2>
        </section>

        <mat-card *ngFor="let comment of selectedTicketComments" class="details-card ts-title">
            <mat-card-title>
                <div class="ticketCreator ts-title" > 
                    {{ comment.creator }} <span class="commented-on">commented on {{ comment.time }}</span>
                </div>
            </mat-card-title>

            <mat-divider></mat-divider>
            <mat-card-content class="ticketDescription ts-title">
                {{ comment.text }}
            </mat-card-content>
        </mat-card>

        <mat-card class="details-card ts-titles">
            <mat-card-content class="ts-title">
                <form class="comments-form ts-title" [formGroup]="addTicketCommentForm" (ngSubmit)="createComment()">

                    <mat-form-field class="example-full-width ts-title">
                        <mat-label>Add a new comment</mat-label>
                        <textarea matInput
                            formControlName="commentDescription"
                            placeholder="Comment"
                            name="commentDescription" required
                            cdkTextareaAutosize
                            cdkAutosizeMinRows="6"
                            cdkAutosizeMaxRows="12">
                        </textarea>
                    </mat-form-field>
                </form>
            </mat-card-content>
            <mat-card-actions class="ts-title">
                <button mat-raised-button (click)="createComment()" color="primary">Add new comment</button>
            </mat-card-actions>
        </mat-card>

    </div>
</div>
